A YANG Data Model for IS-IS Segment Routing over the MPLS Data Plane
RFC 9902
Stephane Litkowski
Cisco Systems
Yingzhen Qu
Futurewei Technologies
Acee Lindem
LabN Consulting, L.L.C.
Ing-Wher Chen
Red Hat, Inc.
Jeff Tantsura
Nvidia
2025-12
RTG
lsr
This document defines a YANG data model that can be used to manage IS-IS extensions for Segment Routing (SR) over the MPLS data plane.
Status of This Memo
This is an Internet Standards Track document.
This document is a product of the Internet Engineering Task Force (IETF). It represents the consensus of the IETF community. It has received public review and has been approved for publication by the Internet Engineering Steering Group (IESG). Further information on Internet Standards is available in Section 2 of RFC 7841.
Information about the current status of this document, any errata, and how to provide feedback on it may be obtained at https://www.rfc-editor.org/info/rfc9902.
Copyright Notice
Copyright (c) 2025 IETF Trust and the persons identified as the document authors. All rights reserved.
This document is subject to BCP 78 and the IETF Trust's Legal Provisions Relating to IETF Documents (https://trustee.ietf.org/license-info) in effect on the date of publication of this document. Please review these documents carefully, as they describe your rights and restrictions with respect to this document. Code Components extracted from this document must include Revised BSD License text as described in Section 4.e of the Trust Legal Provisions and are provided without warranty as described in the Revised BSD License.
Table of Contents
- 1. Overview
  - 1.1. Tree Diagrams
- 2. Design of the YANG Module for IS-IS MPLS Segment Routing
  - 2.1. Segment Routing Activation
  - 2.2. Advertising Mapping Server Policy
  - 2.3. IP Fast Reroute
- 3. IS-IS Segment Routing over MPLS YANG Module
- 4. Security Considerations
- 5. IANA Considerations
- 6. References
  - 6.1. Normative References
  - 6.2. Informative References
- Appendix A. A Configuration Example
- Appendix B. IS-IS MPLS Segment Routing Module Tree
- Acknowledgements
- Authors' Addresses
Overview
This document defines a device YANG data model [RFC7950] that can be used to manage IS-IS extensions for Segment Routing (SR) [RFC8667] over the MPLS data plane. It is an augmentation to the IS-IS YANG data model [RFC9130].
Tree Diagrams
This document uses the graphical representation of a data model as defined in [RFC8340].
Design of the YANG Module for IS-IS MPLS Segment Routing
The IS-IS SR MPLS YANG module requires support for the base SR module [RFC9020], which defines the global SR management independent of any specific routing protocol configuration, and support of the IS-IS base model [RFC9130], which defines the basic IS-IS configuration and state.
The "ietf-isis-sr-mpls" data model defines both the data nodes to configure IS-IS SR MPLS extensions and the additions to the IS-IS Link State Protocol Data Units (LSPs) necessary to support MPLS SR.
Segment Routing Activation
Activation of IS-IS SR MPLS is done by setting the "enable" leaf to true. This triggers advertisement of SR MPLS extensions based on the configuration parameters that have been set up using the base SR module.
Advertising Mapping Server Policy
The base SR module defines mapping server policies. By default, IS-IS will not advertise or process any mapping server entry. The IS-IS SR MPLS module allows the advertisement of one or multiple mapping server policies through the "bindings/advertise/policies" leaf-list. The "bindings/receive" leaf controls the reception and process of mapping server entries.
IP Fast Reroute
The IS-IS SR MPLS module augments the Fast Reroute (FRR) container under interface. It brings the ability to activate Topology Independent Loop-Free Alternate (TI-LFA) and also enhances Remote LFA (RLFA) to use SR tunneling instead of LDP.
IS-IS Segment Routing over MPLS YANG Module
[RFC6991], [RFC8102], [RFC8294], [RFC8349], [RFC8402], [RFC8667], [RFC9020], [RFC9130], and [RFC9855] are referenced in the YANG module.

module ietf-isis-sr-mpls {
  yang-version 1.1;
  namespace "urn:ietf:params:xml:ns:yang:ietf-isis-sr-mpls";
  prefix isis-sr-mpls;

  import ietf-routing {
    prefix rt;
    reference
      "RFC 8349: A YANG Data Model for Routing
                  Management (NMDA Version)";
  }
  import ietf-inet-types {
    prefix inet;
    reference
      "RFC 6991: Common YANG Data Types";
  }
  import ietf-segment-routing-common {
    prefix sr-cmn;
    reference
      "RFC 9020: YANG Data Model for Segment Routing";
  }
  import ietf-segment-routing-mpls {
    prefix sr-mpls;
    reference
      "RFC 9020: YANG Data Model for Segment Routing";
  }
  import ietf-isis {
    prefix isis;
    reference
      "RFC 9130: YANG Data Model for IS-IS Protocol";
  }
  import iana-routing-types {
    prefix iana-rt-types;
    reference
      "RFC 8294: Common YANG Data Types for the Routing Area";
  }
  import ietf-routing-types {
    prefix rt-types;
    reference
      "RFC 8294: Common YANG Data Types for the Routing Area";
  }

  organization
    "IETF LSR - Link State Routing Working Group";
  contact
    "WG Web:   <https://datatracker.ietf.org/wg/lsr/>
     WG List:  <mailto:lsr@ietf.org>

     Author:    Stephane Litkowski
                <mailto:slitkows.ietf@gmail.com>
     Author:    Yingzhen Qu
                <mailto:yingzhen.ietf@gmail.com>
     Author:    Acee Lindem
                <mailto:acee.ietf@gmail.com>
     Author:    Ing-Wher Chen
                <mailto:ichen@redhat.com>
     Author:    Jeff Tantsura
                <mailto:jefftant.ietf@gmail.com>
    ";
  description
    "This YANG module defines the generic configuration and
     operational state for SR IS-IS extensions for the
     MPLS data plane.

     Copyright (c) 2025 IETF Trust and the persons identified as
     authors of the code.  All rights reserved.

     Redistribution and use in source and binary forms, with or
     without modification, is permitted pursuant to, and subject to
     the license terms contained in, the Revised BSD License set
     forth in Section 4.c of the IETF Trust's Legal Provisions
     Relating to IETF Documents
     (https://trustee.ietf.org/license-info).

     This version of this YANG module is part of RFC 9902;
     see the RFC itself for full legal notices.";

  revision 2025-12-09 {
    description
      "Initial revision.";
    reference
      "RFC 9902: A YANG Data Model for IS-IS Segment Routing over
                 the MPLS Data Plane";
  }

  /* Features */

  feature remote-lfa-sr {
    description
      "Enhance RLFA to use SR path.";
    reference
      "RFC 8102: Remote-LFA Node Protection and Manageability";
  }

  feature ti-lfa {
    description
      "Topology Independent Loop-Free Alternate (TI-LFA)
       computation using SR.";
    reference
      "RFC 9855: Topology Independent Fast Reroute Using Segment
       Routing";
  }

  /* Identities */

  identity sr-capability {
    description
      "Base identity for IS-IS SR-Capabilities sub-TLV flags.";
    reference
      "RFC 8667: IS-IS Extensions for Segment Routing";
  }

  identity mpls-ipv4 {
    base sr-capability;
    description
      "If set, then the router is capable of
       processing SR-MPLS-encapsulated IPv4 packets
       on all interfaces.";
  }

  identity mpls-ipv6 {
    base sr-capability;
    description
      "If set, then the router is capable of
       processing SR-MPLS-encapsulated IPv6 packets
       on all interfaces.";
  }

  identity prefix-sid-flag {
    description
      "Base identity for Prefix Segment Identifier (Prefix-SID)
       sub-TLV flags.";
    reference
      "RFC 8667: IS-IS Extensions for Segment Routing, Section 2.1";
  }

  identity r-flag {
    base prefix-sid-flag;
    description
      "Re-advertisement Flag.";
    reference
      "RFC 8667: IS-IS Extensions for Segment Routing, Section 2.1";
  }

  identity n-flag {
    base prefix-sid-flag;
    description
      "Node-SID Flag.";
    reference
      "RFC 8667: IS-IS Extensions for Segment Routing, Section 2.1";
  }

  identity p-flag {
    base prefix-sid-flag;
    description
      "No-PHP (No Penultimate Hop-Popping) Flag.";
    reference
      "RFC 8667: IS-IS Extensions for Segment Routing, Section 2.1";
  }

  identity e-flag {
    base prefix-sid-flag;
    description
      "Explicit NULL Flag.";
    reference
      "RFC 8667: IS-IS Extensions for Segment Routing, Section 2.1";
  }

  identity v-flag {
    base prefix-sid-flag;
    description
      "Value Flag.";
    reference
      "RFC 8667: IS-IS Extensions for Segment Routing, Section 2.1";
  }

  identity l-flag {
    base prefix-sid-flag;
    description
      "Local Flag.";
    reference
      "RFC 8667: IS-IS Extensions for Segment Routing, Section 2.1";
  }

  identity adj-sid-flag {
    description
      "Base identity for Adjacency Segment Identifier (Adj-SID)
       sub-TLV flags.";
    reference
      "RFC 8667: IS-IS Extensions for Segment Routing, Section 2.2";
  }

  identity f-flag {
    base adj-sid-flag;
    description
      "Address-Family Flag.";
    reference
      "RFC 8667: IS-IS Extensions for Segment Routing, Section 2.2";
  }

  identity b-flag {
    base adj-sid-flag;
    description
      "Backup Flag.";
    reference
      "RFC 8667: IS-IS Extensions for Segment Routing, Section 2.2";
  }

  identity vi-flag {
    base adj-sid-flag;
    description
      "Value/Index Flag - corresponds to V-Flag in reference.";
    reference
      "RFC 8667: IS-IS Extensions for Segment Routing, Section 2.2";
  }

  identity lg-flag {
    base adj-sid-flag;
    description
      "Local/Global Flag - corresponds to L-Flag in reference.";
    reference
      "RFC 8667: IS-IS Extensions for Segment Routing, Section 2.2";
  }

  identity s-flag {
    base adj-sid-flag;
    description
      "Set Flag - corresponds to S-Flag in reference.";
    reference
      "RFC 8667: IS-IS Extensions for Segment Routing, Section 2.2";
  }

  identity pe-flag {
    base adj-sid-flag;
    description
      "Persistent Flag - corresponds to P-Flag in reference.";
    reference
      "RFC 8667: IS-IS Extensions for Segment Routing, Section 2.2";
  }

  identity sid-binding-flag {
    description
      "Base identity for SID Binding TLV flags.";
    reference
      "RFC 8667: IS-IS Extensions for Segment Routing, Section 2.4";
  }

  identity af-flag {
    base sid-binding-flag;
    description
      "Address-Family Flag - corresponds to F-Flag in reference.";
    reference
      "RFC 8667: IS-IS Extensions for Segment Routing, Section 2.4";
  }

  identity m-flag {
    base sid-binding-flag;
    description
      "Mirror Context Flag.";
    reference
      "RFC 8667: IS-IS Extensions for Segment Routing, Section 2.4";
  }

  identity sf-flag {
    base sid-binding-flag;
    description
      "S-Flag.  If set, the Label Binding TLV should be flooded
       across the entire routing domain - corresponds to S-Flag in
       reference.";
    reference
      "RFC 8667: IS-IS Extensions for Segment Routing, Section 2.4";
  }

  identity d-flag {
    base sid-binding-flag;
    description
      "Leaking Flag.";
    reference
      "RFC 8667: IS-IS Extensions for Segment Routing, Section 2.4";
  }

  identity a-flag {
    base sid-binding-flag;
    description
      "Attached Flag.";
    reference
      "RFC 8667: IS-IS Extensions for Segment Routing, Section 2.4";
  }

  /* Groupings */

  grouping sid-tlv-encoding {
    description
      "SID TLV Encoding - 20-bit label or 32-bit SID index whose
       interpretation is dependent on the TLV length (3 for an
       MPLS label or 4 for a 32-bit value) or the TLV V-Flag and
       L-Flag settings:

        If the V-Flag is set to 0 and L-Flag is set to 0:
        The SID/Index/Label field is a 4-octet index defining
        the offset in the SID/Label space advertised by this
        router.

        If the V-Flag is set to 1 and L-Flag is set to 1:
        The SID/Index/Label field is a 3-octet local label where the
        20 rightmost bits are used for encoding the label value.";
    reference
      "RFC 8667: IS-IS Extensions for Segment Routing,
       Section 2.1.1.1";
    choice sid {
      case sid-label {
        leaf label-value {
          type uint32 {
            range "0 .. 1048575";
          }
          description
            "A 20-bit MPLS label.";
        }
      }
      case sid-index {
        leaf index-value {
          type uint32;
          description
            "Index into a label space advertised by this router.";
        }
      }
      description
        "Choice of either a 20-bit MPLS label or 32-bit index into
         an advertised label space.";
    }
  }

  grouping sr-capability {
    description
      "SR-Capability grouping.";
    reference
      "RFC 8667: IS-IS Extensions for Segment Routing, Section 3.1";
    container sr-capability {
      description
        "SR-Capability flags.";
      leaf-list sr-capability-flag {
        type identityref {
          base sr-capability;
        }
        description
          "SR-Capability sub-TLV flags.";
      }
      container global-blocks {
        description
          "Segment Routing Global Blocks (SRGBs).";
        list global-block {
          description
            "Segment Routing Global Block.";
          leaf range-size {
            type rt-types:uint24;
            description
              "The SID range.";
          }
          uses sid-tlv-encoding;
        }
      }
    }
  }

  grouping sr-algorithm {
    description
      "SR algorithm grouping.";
    reference
      "RFC 8667: IS-IS Extensions for Segment Routing, Section 3.2";
    container sr-algorithms {
      description
        "All SR algorithms.";
      leaf-list sr-algorithm {
        type identityref {
          base sr-cmn:prefix-sid-algorithm;
        }
        description
          "The SR algorithms that the router is
           currently using.";
      }
    }
  }

  grouping srlb {
    description
      "SR Local Block grouping.";
    reference
      "RFC 8667: IS-IS Extensions for Segment Routing, Section 3.3";
    container local-blocks {
      description
        "List of Segment Routing Local Blocks (SRLBs).";
      list local-block {
        description
          "Segment Routing Local Block.";
        leaf range-size {
          type rt-types:uint24;
          description
            "The SID range.";
        }
        uses sid-tlv-encoding;
      }
    }
  }

  grouping srms-preference {
    description
      "The SR Mapping Server (SRMS) Preference TLV is used to
       advertise a preference associated with the node that acts as
       an SRMS.";
    reference
      "RFC 8667: IS-IS Extensions for Segment Routing, Section 3.4";
    container srms-preference {
      description
        "SRMS Preference TLV.";
      leaf preference {
        type uint8;
        description
          "SRMS Preference TLV, value from 0 to 255 with
           255 being the most preferred.";
      }
    }
  }

  grouping adjacency-state {
    description
      "This grouping extends adjacency state.";
    reference
      "RFC 8667: IS-IS Extensions for Segment Routing, Section 2.2";
    list adjacency-sid {
      config false;
      description
        "List of Adj-SIDs.";
      leaf value {
        type uint32;
        description
          "Value of the Adj-SID.";
      }
      leaf address-family {
        type iana-rt-types:address-family;
        description
          "Address-family associated with the
           segment ID.";
      }
      leaf weight {
        type uint8;
        description
          "Weight associated with
           the Adj-SID.";
      }
      leaf protection-requested {
        type boolean;
        description
          "Describe if the Adj-SID
           must be protected.";
      }
    }
  }

  grouping prefix-sid-sub-tlv {
    description
      "This grouping defines the SR Prefix Segment
       Identifier (Prefix-SID) sub-TLV.";
    reference
      "RFC 8667: IS-IS Extensions for Segment Routing, Section 2.1";
    container prefix-sid-sub-tlvs {
      description
        "Prefix-SID sub-TLVs.";
      list prefix-sid-sub-tlv {
        description
          "List of Prefix-SID sub-TLVs.";
        container prefix-sid-flags {
          description
            "Describes flags associated with the
             segment ID.";
          leaf-list flag {
            type identityref {
              base prefix-sid-flag;
            }
            description
              "Prefix-SID sub-TLV flags.";
          }
        }
        leaf algorithm {
          type identityref {
            base sr-cmn:prefix-sid-algorithm;
          }
          description
            "Algorithm to be used for path computation.";
        }
        uses sid-tlv-encoding;
      }
    }
  }

  grouping adjacency-segment-id {
    description
      "This grouping defines SR extensions
       for adjacencies.";
    reference
      "RFC 8667: IS-IS Extensions for Segment Routing, Section 2.2";
    container adj-sid-sub-tlvs {
      description
        "Adj-SID optional sub-TLVs.";
      list adj-sid-sub-tlv {
        description
          "List of segments.";
        container adj-sid-flags {
          description
            "Adj-SID sub-TLV flags.";
          leaf-list flag {
            type identityref {
              base adj-sid-flag;
            }
            description
              "Adj-SID sub-TLV flags list.";
          }
        }
        leaf weight {
          type uint8;
          description
            "The value represents the weight of the Adj-SID
             for the purpose of load balancing.";
        }
        leaf neighbor-id {
          type isis:system-id;
          description
            "Describes the system ID of the neighbor
             associated with the SID value.  This is only
             used on LAN adjacencies.";
        }
        uses sid-tlv-encoding;
      }
    }
  }

  grouping sid-binding-tlv {
    description
      "SID/Label Binding TLV, type 149.";
    reference
      "RFC 8667: IS-IS Extensions for Segment Routing,
       Section 2.4";
    leaf prefix {
      type inet:ip-prefix;
      description
        "The prefix represents the Forwarding Equivalence
         Class (FEC) at the tail end of the advertised path.";
    }
    leaf range {
      type uint16;
      description
        "Provides the ability to specify a range of addresses
         and their associated Prefix-SIDs.";
    }
    container sid-binding-flags {
      description
        "Binding TLV flags.";
      leaf-list flag {
        type identityref {
          base sid-binding-flag;
        }
        description
          "SID Binding TLV flags.";
      }
    }
    list prefix-sid-sub-tlvs {
      description
        "List of Prefix-SID sub-TLVs.";
      reference
        "RFC 8667: IS-IS Extensions for Segment Routing,
         Section 2.4.4";
      uses prefix-sid-sub-tlv;
    }
    list sid-sub-tlv {
      description
        "List of Prefix-SID sub-TLVs.";
      reference
        "RFC 8667: IS-IS Extensions for Segment Routing,
         Section 2.4.5";
      uses sid-tlv-encoding;
    }
    uses isis:unknown-tlvs;
  }

  /* Configuration */

  augment "/rt:routing/"
        + "rt:control-plane-protocols/rt:control-plane-protocol"
        + "/isis:isis" {
    when "derived-from-or-self(../rt:type, 'isis:isis')" {
      description
        "This augments the IS-IS routing protocol when used.";
    }
    description
      "This augments the IS-IS protocol configuration
       with SR for the MPLS data plane.";
    uses sr-mpls:sr-control-plane;
    container protocol-srgb {
      if-feature "sr-mpls:protocol-srgb";
      description
        "Per-protocol SRGB.";
      reference
        "RFC 8402: Segment Routing Architecture, Section 2";
      uses sr-cmn:srgb;
    }
  }

  augment "/rt:routing/"
        + "rt:control-plane-protocols/rt:control-plane-protocol"
        + "/isis:isis/isis:interfaces/isis:interface" {
    when "derived-from-or-self(../../../rt:type, 'isis:isis')" {
      description
        "This augments the IS-IS routing protocol when used.";
    }
    description
      "This augments the IS-IS protocol configuration
       with SR.";
    uses sr-mpls:igp-interface {
      augment "segment-routing/adjacency-sid/adj-sids" {
        when "../../../isis:interface-type = 'broadcast'" {
          description
            "This augments the broadcast interface.";
        }
        description
          "This augments the LAN interface adj-sid with system-id.";
        leaf neighbor-system-id {
          type isis:system-id;
          mandatory true;
          description
            "Neighbor system ID.";
        }
      }
    }
  }

  augment "/rt:routing/"
        + "rt:control-plane-protocols/rt:control-plane-protocol"
        + "/isis:isis/isis:interfaces/isis:interface"
        + "/isis:fast-reroute/isis:lfa" {
    when "derived-from-or-self(../../../../../rt:type,"
       + "'isis:isis')" {
      description
        "This augments the IS-IS routing protocol when used.";
    }
    description
      "This augments the IS-IS interface IP Fast Reroute (IP-FRR)
       with TI-LFA.";
    container ti-lfa {
      if-feature "ti-lfa";
      description
        "Topology Independent Loop-Free Alternate
         (TI-LFA) support.";
      leaf enabled {
        type boolean;
        default "false";
        description
          "Enables TI-LFA computation.";
      }
      container selection-tie-breakers {
        description
          "Configure path selection tie-breakers and their
           respective priorities for the TI-LFA computation.";
        container node-protection {
          presence "Presence of container enables the node
                    protection tie-breaker.";
          description
            "Enable node protection as a TI-LFA path
             selection tie-breaker.  A path providing node
             protection will be selected over one that
             doesn't provide node protection.";
          leaf priority {
            type uint8;
            default "128";
            description
              "Priority for node protection tie-breaker with
               a lower priority being more preferred.";
          }
        }
        container srlg-disjoint {
          presence "Presence of container enables the SRLG
                    disjoint tie-breaker.";
          description
            "Enable Shared Risk Link Group (SRLG)
             disjoint as a TI-LFA path selection tie-breaker.
             A path providing a node with a disjoint path for SRLG
             links from the primary path will be selected over
             a path that doesn't provide an SRLG disjoint path.";
          leaf priority {
            type uint8;
            default "128";
            description
              "Priority for SRLG disjoint tie-breaker with
               a lower priority being more preferred.";
          }
        }
      }
    }
  }

  augment "/rt:routing/"
        + "rt:control-plane-protocols/rt:control-plane-protocol"
        + "/isis:isis/isis:interfaces/isis:interface"
        + "/isis:fast-reroute/isis:lfa/isis:level-1" {
    when "derived-from-or-self(../../../../../../rt:type,"
       + "'isis:isis')" {
      description
        "This augments the IS-IS routing protocol when used.";
    }
    description
      "This augments the IS-IS interface level-1 IP FRR with
       TI-LFA.";
    container ti-lfa {
      if-feature "ti-lfa";
      description
        "TI-LFA configuration.";
      leaf enabled {
        type boolean;
        default "false";
        description
          "Enables TI-LFA computation.";
      }
    }
  }

  augment "/rt:routing/"
        + "rt:control-plane-protocols/rt:control-plane-protocol"
        + "/isis:isis/isis:interfaces/isis:interface"
        + "/isis:fast-reroute/isis:lfa/isis:level-2" {
    when "derived-from-or-self(../../../../../../rt:type,"
       + "'isis:isis')" {
      description
        "This augments the IS-IS routing protocol when used.";
    }
    description
      "This augments the IS-IS interface level-2 IP FRR with
       TI-LFA.";
    container ti-lfa {
      if-feature "ti-lfa";
      description
        "TI-LFA configuration.";
      leaf enabled {
        type boolean;
        default "false";
        description
          "Enables TI-LFA computation.";
      }
    }
  }

  augment "/rt:routing/"
        + "rt:control-plane-protocols/rt:control-plane-protocol"
        + "/isis:isis/isis:interfaces/isis:interface"
        + "/isis:fast-reroute/isis:lfa/isis:remote-lfa" {
    when "derived-from-or-self(../../../../../../rt:type,"
       + "'isis:isis')" {
      description
        "This augments the IS-IS routing protocol when used.";
    }
    description
      "This augments the IS-IS RLFA configuration with
       use of the SR path.";
    leaf use-segment-routing-path {
      if-feature "remote-lfa-sr";
      type boolean;
      default "false";
      description
        "Force RLFA to use the SR path instead of
         LDP path.  The value of this leaf is in effect only when
         remote-lfa is enabled.";
    }
  }

  /* Operational states */

  augment "/rt:routing/"
        + "rt:control-plane-protocols/rt:control-plane-protocol"
        + "/isis:isis/isis:interfaces/isis:interface"
        + "/isis:adjacencies/isis:adjacency" {
    when "derived-from-or-self(../../../../../rt:type,"
       + "'isis:isis')" {
      description
        "This augments the IS-IS routing protocol when used.";
    }
    description
      "This augments the IS-IS protocol configuration
       with SR.";
    uses adjacency-state;
  }

  augment "/rt:routing/"
        + "rt:control-plane-protocols/rt:control-plane-protocol"
        + "/isis:isis/isis:database/isis:levels/isis:lsp"
        + "/isis:router-capabilities/isis:router-capability" {
    when "derived-from-or-self(../../../../../../rt:type,"
       + "'isis:isis')" {
      description
        "This augments the IS-IS routing protocol when used.";
    }
    description
      "This augments the IS-IS protocol Link State Database (LSDB)
       router capability.";
    uses sr-capability;
    uses sr-algorithm;
    uses srlb;
    uses srms-preference;
  }

  augment "/rt:routing/"
        + "rt:control-plane-protocols/rt:control-plane-protocol"
        + "/isis:isis/isis:database/isis:levels/isis:lsp"
        + "/isis:extended-is-neighbor/isis:neighbor/isis:instances"
        + "/isis:instance" {
    when "derived-from-or-self(../../../../../../../../rt:type,"
       + "'isis:isis')" {
      description
        "This augments the IS-IS routing protocol when used.";
    }
    description
      "This augments the IS-IS protocol LSDB neighbor.";
    uses adjacency-segment-id;
  }

  augment "/rt:routing/"
        + "rt:control-plane-protocols/rt:control-plane-protocol"
        + "/isis:isis/isis:database/isis:levels/isis:lsp"
        + "/isis:mt-is-neighbor/isis:neighbor/isis:instances"
        + "/isis:instance" {
    when "derived-from-or-self(../../../../../../../../rt:type,"
       + "'isis:isis')" {
      description
        "This augments the IS-IS routing protocol when used.";
    }
    description
      "This augments the IS-IS protocol LSDB neighbor.";
    uses adjacency-segment-id;
  }

  augment "/rt:routing/"
        + "rt:control-plane-protocols/rt:control-plane-protocol"
        + "/isis:isis/isis:database/isis:levels/isis:lsp"
        + "/isis:extended-ipv4-reachability/isis:prefixes" {
    when "derived-from-or-self(../../../../../../rt:type,"
       + "'isis:isis')" {
      description
        "This augments the IS-IS routing protocol when used.";
    }
    description
      "This augments the IS-IS protocol LSDB prefix.";
    uses prefix-sid-sub-tlv;
  }

  augment "/rt:routing/"
        + "rt:control-plane-protocols/rt:control-plane-protocol"
        + "/isis:isis/isis:database/isis:levels/isis:lsp"
        + "/isis:mt-extended-ipv4-reachability/isis:prefixes" {
    when "derived-from-or-self(../../../../../../rt:type,"
       + "'isis:isis')" {
      description
        "This augments the IS-IS routing protocol when used.";
    }
    description
      "This augments the IS-IS protocol LSDB prefix.";
    uses prefix-sid-sub-tlv;
  }

  augment "/rt:routing/"
        + "rt:control-plane-protocols/rt:control-plane-protocol"
        + "/isis:isis/isis:database/isis:levels/isis:lsp"
        + "/isis:ipv6-reachability/isis:prefixes" {
    when "derived-from-or-self(../../../../../../rt:type,"
       + "'isis:isis')" {
      description
        "This augments the IS-IS routing protocol when used.";
    }
    description
      "This augments the IS-IS protocol LSDB prefix.";
    uses prefix-sid-sub-tlv;
  }

  augment "/rt:routing/"
        + "rt:control-plane-protocols/rt:control-plane-protocol"
        + "/isis:isis/isis:database/isis:levels/isis:lsp"
        + "/isis:mt-ipv6-reachability/isis:prefixes" {
    when "derived-from-or-self(../../../../../../rt:type,"
       + "'isis:isis')" {
      description
        "This augments the IS-IS routing protocol when used.";
    }
    description
      "This augments the IS-IS protocol LSDB prefix.";
    uses prefix-sid-sub-tlv;
  }

  augment "/rt:routing/"
        + "rt:control-plane-protocols/rt:control-plane-protocol"
        + "/isis:isis/isis:database/isis:levels/isis:lsp" {
    when "derived-from-or-self(../../../../rt:type,"
       + "'isis:isis')" {
      description
        "This augments the IS-IS routing protocol when used.";
    }
    description
      "This augments the IS-IS protocol LSDB.";
    container sid-binding-tlvs {
      description
        "List of SID/Label Binding TLVs.";
      list sid-binding-tlv {
        key "prefix";
        description
          "SID/Label Binding TLV, type 149.";
        uses sid-binding-tlv;
      }
    }
    container mt-sid-binding-tlvs {
      description
        "List of Multi-Topology SID/Label Binding TLVs.";
      list mt-sid-binding-tlv {
        key "prefix mt-id";
        description
          "Multi-Topology SID/Label Binding TLV, type 150.";
        reference
          "RFC 8667: IS-IS Extensions for Segment Routing,
           Section 2.5";
        uses sid-binding-tlv;
        leaf mt-id {
          type uint16;
          description
            "A 12-bit field containing the non-zero ID
             of the topology.";
        }
      }
    }
  }
}

Security Considerations
This section is modeled after the template described in Section 3.7 of [YANG-GUIDE].
The "ietf-isis-sr-mpls" YANG module defines a data model that is designed to be accessed via YANG-based management protocols, such as NETCONF [RFC6241] and RESTCONF [RFC8040]. These YANG-based management protocols (1) have to use a secure transport layer (e.g., SSH [RFC4252], TLS [RFC8446], and QUIC [RFC9000]) and (2) have to use mutual authentication.
The Network Configuration Access Control Model (NACM) [RFC8341] provides the means to restrict access for particular NETCONF or RESTCONF users to a preconfigured subset of all available NETCONF or RESTCONF protocol operations and content.
There are a number of data nodes defined in this YANG module that are writable/creatable/deletable (i.e., "config true", which is the default). All writable data nodes are likely to be sensitive or vulnerable in some network environments. Write operations (e.g., edit-config) and delete operations to these data nodes without proper protection or authentication can have a negative effect on network operations. The following subtrees and data nodes have particular sensitivities/vulnerabilities:
- /isis:isis/segment-routing
- /isis:isis/protocol-srgb
- /isis:isis/isis:interfaces/isis:interface/segment-routing
- /isis:isis/isis:interfaces/isis:interface/isis:fast-reroute/ti-lfa
The ability to disable or enable IS-IS SR support and/or change SR configurations can result in a Denial-of-Service (DoS) attack, as this may cause traffic to be dropped or misrouted. Please refer to Section 5 of [RFC8667] for more information on SR extensions.
Some of the readable data nodes in this YANG module may be considered sensitive or vulnerable in some network environments. It is thus important to control read access (e.g., via get, get-config, or notification) to these data nodes. Specifically, the following subtrees and data nodes have particular sensitivities/vulnerabilities:
- /isis:router-capabilities/sr-capability
- /isis:router-capabilities/sr-algorithms
- /isis:router-capabilities/local-blocks
- /isis:router-capabilities/srms-preference
- and the augmentations to the IS-IS LSDB.
Unauthorized access to any data node of these subtrees can disclose the operational state information of the IS-IS protocol on a device.
There are no particularly sensitive RPC or action operations.
IANA Considerations
The IANA has assigned one new URI in the "IETF XML Registry" [RFC3688]:
URI:
urn:ietf:params:xml:ns:yang:ietf-isis-sr-mpls
Registrant Contact:
The IESG.
XML:
N/A; the requested URI is an XML namespace
This document also registers one new YANG module name in the "YANG Module Names" registry [RFC6020]:
Name:
ietf-isis-sr-mpls
Maintained by IANA?
N
Namespace:
urn:ietf:params:xml:ns:yang:ietf-isis-sr-mpls
Prefix:
isis-sr-mpls
Reference:
RFC 9902
References
Normative References
[RFC3688]

The IETF XML Registry
M. Mealling
January 2004
BCP 81
RFC 3688
DOI 10.17487/RFC3688
[RFC6020]

YANG - A Data Modeling Language for the Network Configuration Protocol (NETCONF)
M. Bjorklund, Ed.
October 2010
RFC 6020
DOI 10.17487/RFC6020
[RFC6991]

Common YANG Data Types
J. Schoenwaelder, Ed.
July 2013
RFC 6991
DOI 10.17487/RFC6991
[RFC7950]

The YANG 1.1 Data Modeling Language
M. Bjorklund, Ed.
August 2016
RFC 7950
DOI 10.17487/RFC7950
[RFC8102]

Remote-LFA Node Protection and Manageability
P. Sarkar, Ed.
S. Hegde
C. Bowers
H. Gredler
S. Litkowski
March 2017
RFC 8102
DOI 10.17487/RFC8102
[RFC8294]

Common YANG Data Types for the Routing Area
X. Liu
Y. Qu
A. Lindem
C. Hopps
L. Berger
December 2017
RFC 8294
DOI 10.17487/RFC8294
[RFC8341]

Network Configuration Access Control Model
A. Bierman
M. Bjorklund
March 2018
STD 91
RFC 8341
DOI 10.17487/RFC8341
[RFC8349]

A YANG Data Model for Routing Management (NMDA Version)
L. Lhotka
A. Lindem
Y. Qu
March 2018
RFC 8349
DOI 10.17487/RFC8349
[RFC8402]

Segment Routing Architecture
C. Filsfils, Ed.
S. Previdi, Ed.
L. Ginsberg
B. Decraene
S. Litkowski
R. Shakir
July 2018
RFC 8402
DOI 10.17487/RFC8402
[RFC8667]

IS-IS Extensions for Segment Routing
S. Previdi, Ed.
L. Ginsberg, Ed.
C. Filsfils
A. Bashandy
H. Gredler
B. Decraene
December 2019
RFC 8667
DOI 10.17487/RFC8667
[RFC9020]

YANG Data Model for Segment Routing
S. Litkowski
Y. Qu
A. Lindem
P. Sarkar
J. Tantsura
May 2021
RFC 9020
DOI 10.17487/RFC9020
[RFC9130]

YANG Data Model for the IS-IS Protocol
S. Litkowski, Ed.
D. Yeung
A. Lindem
J. Zhang
L. Lhotka
October 2022
RFC 9130
DOI 10.17487/RFC9130
[RFC9855]

Topology Independent Fast Reroute Using Segment Routing
A. Bashandy
S. Litkowski
C. Filsfils
P. Francois
B. Decraene
D. Voyer
October 2025
RFC 9855
DOI 10.17487/RFC9855
Informative References
[RFC4252]

The Secure Shell (SSH) Authentication Protocol
T. Ylonen
C. Lonvick, Ed.
January 2006
RFC 4252
DOI 10.17487/RFC4252
[RFC6241]

Network Configuration Protocol (NETCONF)
R. Enns, Ed.
M. Bjorklund, Ed.
J. Schoenwaelder, Ed.
A. Bierman, Ed.
June 2011
RFC 6241
DOI 10.17487/RFC6241
[RFC8040]

RESTCONF Protocol
A. Bierman
M. Bjorklund
K. Watsen
January 2017
RFC 8040
DOI 10.17487/RFC8040
[RFC8340]

YANG Tree Diagrams
M. Bjorklund
L. Berger, Ed.
March 2018
BCP 215
RFC 8340
DOI 10.17487/RFC8340
[RFC8446]

The Transport Layer Security (TLS) Protocol Version 1.3
E. Rescorla
August 2018
RFC 8446
DOI 10.17487/RFC8446
[RFC8792]

Handling Long Lines in Content of Internet-Drafts and RFCs
K. Watsen
E. Auerswald
A. Farrel
Q. Wu
June 2020
RFC 8792
DOI 10.17487/RFC8792
[RFC9000]

QUIC: A UDP-Based Multiplexed and Secure Transport
J. Iyengar, Ed.
M. Thomson, Ed.
May 2021
RFC 9000
DOI 10.17487/RFC9000
[I-D.ietf-netmod-rfc8407bis]

Guidelines for Authors and Reviewers of Documents Containing YANG Data Models
Andy Bierman
YumaWorks
Mohamed Boucadair
Orange
Qin Wu
Huawei
5 June 2025
Internet-Draft draft-ietf-netmod-rfc8407bis-28
Work in Progress
A Configuration Example
The following is an XML example using the IS-IS SR MPLS YANG module defined in this document.
Note: '\' line wrapping per [RFC8792].

<?xml version='1.0' encoding='UTF-8'?>
<interfaces xmlns="urn:ietf:params:xml:ns:yang:ietf-interfaces">
  <interface>
    <name>eth0</name>
    <admin-status>up</admin-status>
    <oper-status>up</oper-status>
    <if-index>1</if-index>
    <statistics>
      <discontinuity-time>2024-10-27T14:30:00Z</discontinuity-time>
    </statistics>
  </interface>
</interfaces>
<routing xmlns="urn:ietf:params:xml:ns:yang:ietf-routing">
 <router-id>1.1.1.1</router-id>
 <control-plane-protocols>
   <control-plane-protocol>
     <type xmlns:isis="urn:ietf:params:xml:ns:yang:ietf-isis">\
       isis:isis</type>
     <name>isis</name>
     <isis xmlns="urn:ietf:params:xml:ns:yang:ietf-isis">
       <system-id>1111.2222.3333</system-id>
       <area-address>49.0001.0000.0000.0001</area-address>
       <interfaces>
         <interface>
           <name>eth0</name>
           <segment-routing xmlns="urn:ietf:params:xml:ns:yang:\
             ietf-isis-sr-mpls">
             <adjacency-sid>
               <adj-sids>
                 <value>38888</value>
                 <neighbor-system-id>4444.5555.6666\
                 </neighbor-system-id>
               </adj-sids>
             </adjacency-sid>
           </segment-routing>
         </interface>
       </interfaces>
       <segment-routing xmlns="urn:ietf:params:xml:ns:yang:\
         ietf-isis-sr-mpls">
         <enabled>true</enabled>
       </segment-routing>
       <protocol-srgb xmlns="urn:ietf:params:xml:ns:yang:\
         ietf-isis-sr-mpls">
         <srgb>
           <lower-bound>4000</lower-bound>
           <upper-bound>5000</upper-bound>
         </srgb>
       </protocol-srgb>
       </isis>
    </control-plane-protocol>
 </control-plane-protocols>
</routing>

The following is the same example using JSON format.

{
  "ietf-interfaces:interfaces": {
    "interface": [
      {
        "name": "eth0",
        "admin-status": "up",
        "oper-status": "up",
        "if-index": 1,
        "statistics": {
          "discontinuity-time": "2024-10-27T07:30:00-07:00"
        }
      }
    ]
  },
  "ietf-routing:routing": {
    "router-id": "1.1.1.1",
    "control-plane-protocols": {
      "control-plane-protocol": [
        {
          "type": "ietf-isis:isis",
          "name": "isis",
          "ietf-isis:isis": {
            "system-id": "1111.2222.3333",
            "area-address": [
              "49.0001.0000.0000.0001"
            ],
            "interfaces": {
              "interface": [
                {
                  "name": "eth0",
                  "ietf-isis-sr-mpls:segment-routing": {
                    "adjacency-sid": {
                      "adj-sids": [
                        {
                          "value": 38888,
                          "neighbor-system-id": "4444.5555.6666"
                        }
                      ]
                    }
                  }
                }
              ]
            },
            "ietf-isis-sr-mpls:segment-routing": {
              "enabled": true
            },
            "ietf-isis-sr-mpls:protocol-srgb": {
              "srgb": [
                {
                  "lower-bound": 4000,
                  "upper-bound": 5000
                }
              ]
            }
          }
        }
      ]
    }
  }
}

IS-IS MPLS Segment Routing Module Tree
The figure below describes the overall structure of the "ietf-isis-sr-mpls" YANG module:

augment /rt:routing/rt:control-plane-protocols
          /rt:control-plane-protocol/isis:isis:
  +--rw segment-routing
  |  +--rw enabled?    boolean
  |  +--rw bindings {mapping-server}?
  |     +--rw advertise
  |     |  +--rw policies*   leafref
  |     +--rw receive?     boolean
  +--rw protocol-srgb {sr-mpls:protocol-srgb}?
     +--rw srgb* [lower-bound upper-bound]
        +--rw lower-bound    uint32
        +--rw upper-bound    uint32
augment /rt:routing/rt:control-plane-protocols
          /rt:control-plane-protocol/isis:isis/isis:interfaces
          /isis:interface:
  +--rw segment-routing
     +--rw adjacency-sid
        +--rw adj-sids* [value]
        |  +--rw value-type?           enumeration
        |  +--rw value                 uint32
        |  +--rw protected?            boolean
        |  +--rw weight?               uint8
        |  +--rw neighbor-system-id    isis:system-id
        +--rw advertise-adj-group-sid* [group-id]
        |  +--rw group-id    uint32
        +--rw advertise-protection?      enumeration
augment /rt:routing/rt:control-plane-protocols
          /rt:control-plane-protocol/isis:isis/isis:interfaces
          /isis:interface/isis:fast-reroute/isis:lfa:
  +--rw ti-lfa {ti-lfa}?
     +--rw enabled?                  boolean
     +--rw selection-tie-breakers
        +--rw node-protection!
        |  +--rw priority?   uint8
        +--rw srlg-disjoint!
           +--rw priority?   uint8
augment /rt:routing/rt:control-plane-protocols
          /rt:control-plane-protocol/isis:isis/isis:interfaces
          /isis:interface/isis:fast-reroute/isis:lfa/isis:level-1:
  +--rw ti-lfa {ti-lfa}?
     +--rw enabled?   boolean
augment /rt:routing/rt:control-plane-protocols
          /rt:control-plane-protocol/isis:isis/isis:interfaces
          /isis:interface/isis:fast-reroute/isis:lfa/isis:level-2:
  +--rw ti-lfa {ti-lfa}?
     +--rw enabled?   boolean
augment /rt:routing/rt:control-plane-protocols
          /rt:control-plane-protocol/isis:isis/isis:interfaces
          /isis:interface/isis:fast-reroute/isis:lfa
          /isis:remote-lfa:
  +--rw use-segment-routing-path?   boolean {remote-lfa-sr}?
augment /rt:routing/rt:control-plane-protocols
          /rt:control-plane-protocol/isis:isis/isis:interfaces
          /isis:interface/isis:adjacencies/isis:adjacency:
  +--ro adjacency-sid* []
     +--ro value?                  uint32
     +--ro address-family?         iana-rt-types:address-family
     +--ro weight?                 uint8
     +--ro protection-requested?   boolean
augment /rt:routing/rt:control-plane-protocols
          /rt:control-plane-protocol/isis:isis/isis:database
          /isis:levels/isis:lsp/isis:router-capabilities
          /isis:router-capability:
  +--ro sr-capability
  |  +--ro sr-capability-flag*   identityref
  |  +--ro global-blocks
  |     +--ro global-block* []
  |        +--ro range-size?          rt-types:uint24
  |        +--ro (sid)?
  |           +--:(sid-label)
  |           |  +--ro label-value?   uint32
  |           +--:(sid-index)
  |              +--ro index-value?   uint32
  +--ro sr-algorithms
  |  +--ro sr-algorithm*   identityref
  +--ro local-blocks
  |  +--ro local-block* []
  |     +--ro range-size?          rt-types:uint24
  |     +--ro (sid)?
  |        +--:(sid-label)
  |        |  +--ro label-value?   uint32
  |        +--:(sid-index)
  |           +--ro index-value?   uint32
  +--ro srms-preference
     +--ro preference?   uint8
augment /rt:routing/rt:control-plane-protocols
          /rt:control-plane-protocol/isis:isis/isis:database
          /isis:levels/isis:lsp/isis:extended-is-neighbor
          /isis:neighbor/isis:instances/isis:instance:
  +--ro adj-sid-sub-tlvs
     +--ro adj-sid-sub-tlv* []
        +--ro adj-sid-flags
        |  +--ro flag*   identityref
        +--ro weight?              uint8
        +--ro neighbor-id?         isis:system-id
        +--ro (sid)?
           +--:(sid-label)
           |  +--ro label-value?   uint32
           +--:(sid-index)
              +--ro index-value?   uint32
augment /rt:routing/rt:control-plane-protocols
          /rt:control-plane-protocol/isis:isis/isis:database
          /isis:levels/isis:lsp/isis:mt-is-neighbor/isis:neighbor
          /isis:instances/isis:instance:
  +--ro adj-sid-sub-tlvs
     +--ro adj-sid-sub-tlv* []
        +--ro adj-sid-flags
        |  +--ro flag*   identityref
        +--ro weight?              uint8
        +--ro neighbor-id?         isis:system-id
        +--ro (sid)?
           +--:(sid-label)
           |  +--ro label-value?   uint32
           +--:(sid-index)
              +--ro index-value?   uint32
augment /rt:routing/rt:control-plane-protocols
          /rt:control-plane-protocol/isis:isis/isis:database
          /isis:levels/isis:lsp/isis:extended-ipv4-reachability
          /isis:prefixes:
  +--ro prefix-sid-sub-tlvs
     +--ro prefix-sid-sub-tlv* []
        +--ro prefix-sid-flags
        |  +--ro flag*   identityref
        +--ro algorithm?           identityref
        +--ro (sid)?
           +--:(sid-label)
           |  +--ro label-value?   uint32
           +--:(sid-index)
              +--ro index-value?   uint32
augment /rt:routing/rt:control-plane-protocols
          /rt:control-plane-protocol/isis:isis/isis:database
          /isis:levels/isis:lsp/isis:mt-extended-ipv4-reachability
          /isis:prefixes:
  +--ro prefix-sid-sub-tlvs
     +--ro prefix-sid-sub-tlv* []
        +--ro prefix-sid-flags
        |  +--ro flag*   identityref
        +--ro algorithm?           identityref
        +--ro (sid)?
           +--:(sid-label)
           |  +--ro label-value?   uint32
           +--:(sid-index)
              +--ro index-value?   uint32
augment /rt:routing/rt:control-plane-protocols
          /rt:control-plane-protocol/isis:isis/isis:database
          /isis:levels/isis:lsp/isis:ipv6-reachability
          /isis:prefixes:
  +--ro prefix-sid-sub-tlvs
     +--ro prefix-sid-sub-tlv* []
        +--ro prefix-sid-flags
        |  +--ro flag*   identityref
        +--ro algorithm?           identityref
        +--ro (sid)?
           +--:(sid-label)
           |  +--ro label-value?   uint32
           +--:(sid-index)
              +--ro index-value?   uint32
augment /rt:routing/rt:control-plane-protocols
          /rt:control-plane-protocol/isis:isis/isis:database
          /isis:levels/isis:lsp/isis:mt-ipv6-reachability
          /isis:prefixes:
  +--ro prefix-sid-sub-tlvs
     +--ro prefix-sid-sub-tlv* []
        +--ro prefix-sid-flags
        |  +--ro flag*   identityref
        +--ro algorithm?           identityref
        +--ro (sid)?
           +--:(sid-label)
           |  +--ro label-value?   uint32
           +--:(sid-index)
              +--ro index-value?   uint32
augment /rt:routing/rt:control-plane-protocols
          /rt:control-plane-protocol/isis:isis/isis:database
          /isis:levels/isis:lsp:
  +--ro sid-binding-tlvs
  |  +--ro sid-binding-tlv* [prefix]
  |     +--ro prefix                 inet:ip-prefix
  |     +--ro range?                 uint16
  |     +--ro sid-binding-flags
  |     |  +--ro flag*   identityref
  |     +--ro prefix-sid-sub-tlvs* []
  |     |  +--ro prefix-sid-sub-tlvs
  |     |     +--ro prefix-sid-sub-tlv* []
  |     |        +--ro prefix-sid-flags
  |     |        |  +--ro flag*   identityref
  |     |        +--ro algorithm?           identityref
  |     |        +--ro (sid)?
  |     |           +--:(sid-label)
  |     |           |  +--ro label-value?   uint32
  |     |           +--:(sid-index)
  |     |              +--ro index-value?   uint32
  |     +--ro sid-sub-tlv* []
  |     |  +--ro (sid)?
  |     |     +--:(sid-label)
  |     |     |  +--ro label-value?   uint32
  |     |     +--:(sid-index)
  |     |        +--ro index-value?   uint32
  |     +--ro unknown-tlvs
  |        +--ro unknown-tlv* []
  |           +--ro type?     uint16
  |           +--ro length?   uint16
  |           +--ro value?    yang:hex-string
  +--ro mt-sid-binding-tlvs
     +--ro mt-sid-binding-tlv* [prefix mt-id]
        +--ro prefix                 inet:ip-prefix
        +--ro range?                 uint16
        +--ro sid-binding-flags
        |  +--ro flag*   identityref
        +--ro prefix-sid-sub-tlvs* []
        |  +--ro prefix-sid-sub-tlvs
        |     +--ro prefix-sid-sub-tlv* []
        |        +--ro prefix-sid-flags
        |        |  +--ro flag*   identityref
        |        +--ro algorithm?           identityref
        |        +--ro (sid)?
        |           +--:(sid-label)
        |           |  +--ro label-value?   uint32
        |           +--:(sid-index)
        |              +--ro index-value?   uint32
        +--ro sid-sub-tlv* []
        |  +--ro (sid)?
        |     +--:(sid-label)
        |     |  +--ro label-value?   uint32
        |     +--:(sid-index)
        |        +--ro index-value?   uint32
        +--ro unknown-tlvs
        |  +--ro unknown-tlv* []
        |     +--ro type?     uint16
        |     +--ro length?   uint16
        |     +--ro value?    yang:hex-string
        +--ro mt-id                  uint16

Acknowledgements
The authors would like to thank Pushpasis Sarkar, Derek Yeung, and Yi Yang for their major contributions to the document. Also thanks to Reshad Rahman, Tom Petch, and Renato Westphal for their thorough reviews and helpful comments.
The authors wish to thank Mohamed Boucadair and Ketan Talaulikar for extensive AD reviews for the IESG Telechat. Thanks to Éric Vyncke and Mahesh Jethanandani for review comments.
Authors' Addresses
Stephane Litkowski
Cisco Systems
slitkows.ietf@gmail.com
Yingzhen Qu
Futurewei Technologies
yingzhen.ietf@gmail.com
Acee Lindem
LabN Consulting, L.L.C.
acee.ietf@gmail.com
Ing-Wher Chen
Red Hat, Inc.
ichen@redhat.com
Jeff Tantsura
Nvidia
jefftant.ietf@gmail.com